﻿using UnityEngine;
using System.Collections;
using AssetBundles;

/// <summary>
/// AssetBundleManagerを使って
/// 
/// </summary>
public class LoadSceneFromAssetBundles : MonoBehaviour {
	/// <summary>
	/// アセットバンドルのURL。
	/// </summary>
	const string AssetBundleBaseURL = "http://naochang.me/wp-content/entries/151022_AssetBundles/AssetBundlesManager/";

	/// <summary>
	/// シーンの入ったアセットバンドルの名前。
	/// </summary>
	const string SceneAssetBundleName = "scenes";

	/// <summary>
	/// 読み込むシーン名。
	/// </summary>
	public string sceneName;

	/// <summary>
	/// Start.
	/// </summary>
	IEnumerator Start() {
		yield return StartCoroutine(this.Initialize());
		yield return StartCoroutine(this.InitializeLevelAsync(this.sceneName, false));
	}

	/// <summary>
	/// 初期化。
	/// </summary>
	IEnumerator Initialize() {
		DontDestroyOnLoad(gameObject);

		#if DEVELOPMENT_BUILD || UNITY_EDITOR
		AssetBundleManager.SetDevelopmentAssetBundleServer ();
		#else
		AssetBundleManager.SetSourceAssetBundleURL(LoadSceneFromAssetBundles.AssetBundleBaseURL);
		#endif

		var request = AssetBundleManager.Initialize();

		if (request != null)
			yield return StartCoroutine(request);
	}

	/// <summary>
	/// シーンを読み込む。
	/// </summary>
	protected IEnumerator InitializeLevelAsync(string sceneName, bool isAdditive) {
		AssetBundleLoadOperation request = AssetBundleManager.LoadLevelAsync(LoadSceneFromAssetBundles.SceneAssetBundleName, sceneName, isAdditive);

		if (request == null)
			yield break;

		yield return StartCoroutine(request);
	}
}
